﻿#!/perl/bin/perl
#
# player.pl 差し替え版 2010/5/29
#
# segwrapperの場所
use lib 'C:\perlrtmp\lib';
use Encode;
###############################################
use segwrapper; 
require 'define.pl';
use Time::Local;
use LWP::UserAgent;
use Win32::Process;
use Win32;
$packet_size = 4096;

if($ENV{'HTTP_USER_AGENT'} =~ /iphone|ipod/i){
	$brtype = 1;
	$Thumb = 0;
	$Caption = 0;
	$MP4Archiver = 0;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /ipad/i){
	$brtype = 1;
	$Caption = 0;
	$MP4Archiver = 0;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /chrome/i){
	$brtype = 2;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /firefox/i){
	$brtype = 3;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /msie/i){
	$brtype = 4;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /opera/i){
	if(($ENV{'HTTP_USER_AGENT'} =~ /windows ce/i) ||
	   ($ENV{'HTTP_USER_AGENT'} =~ /$WMdevice/i)){	# DoCoMo
		$brtype = 6;
		$RwIPOD = "";
		$Thumb = 0;
		$Caption = 0;
		$MP4Archiver = 0;
	}else{
		$brtype = 5;
	}
}elsif($ENV{'HTTP_USER_AGENT'} =~ /playstation 3/i){
	$brtype = 7;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /iris/i){
		$brtype = 8;
		$Thumb = 0;
		$Caption = 0;
		$MP4Archiver = 0;
}else{
	$brtype = 0;
}

$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
if($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $omsgid, $ENV{'CONTENT_LENGTH'});
}else{
	$omsgid = $ENV{'QUERY_STRING'};
}
if ($omsgid eq '') {
	if ($ENV{'PATH_INFO'} ne '') {
		$omsgid = $ENV{'PATH_INFO'};
		$omsgid =~ s/\///g;
	}
}

if($omsgid =~ /cachename=([0-9]+)/){
	$cacheName = $1;
	if($omsgid =~ /bc/){
		@bcS = @bciS = ();
		@inputs = split(/&/, $omsgid);
		foreach (@inputs){
			($name, $value) = split(/=/);
			$value =~ tr/+//;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ s/\r|\n/\n/g;
			$value =~ s/~!/ ~!/g;
			if($name eq "bc"){ push(@bcS, $value); }
			if($name eq "bci"){ $FBCI{$value} = 'i'; }
			foreach $mcb (@bcS) {
				unless($FBCI{$mcb}){ $FBCI{$mcb} = 'p'; }
 			}
		}
	}

	if($omsgid =~ /abort=(.*)$/){	#エンコード処理中断
		$AbortName = $mp4_folder . "\\" . $1 . '.abt';
		open(ABT, ">$AbortName"); close(ABT);
		sleep(3);
	}

	&nres("", $cacheName);
	exit(0);
}

($msgid, $mode, $fill) = split(/&/, $omsgid);
$msgid =~ s/[\x00-\x1F]//g;
($day,$st_tim,$ed_tim,$ch)=split("-",$msgid);
if (($day !~ /^\d{6,6}$/) || ($st_tim !~ /^\d{6,6}$/) || ($ed_tim !~ /^\d{6,6}$/) || ($ch !~ /^\d+$/)) {
	if($omsgid =~ /mode=10/){		# 文字列検索
		$outQuery = "mode=10&site=032&lhour=24&sort=d&shour=$startH&area=$my_area&category=$tcategory&template=result";
		@inputs = split(/&/, $omsgid);
		foreach (@inputs){
			($name, $value) = split(/=/);
			$value =~ tr/+//;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ s/\r|\n/\n/g;
			$value =~ s/~!/ ~!/g;
			if($name eq "SDate"){ $outQuery .= "&sdate=" . $value; }
			if($name eq "Period"){ $value -= 1; $outQuery .= "&ldate=" . $value; }
			if($name eq "Search"){
				#&jcode'convert(*value, 'sjis');
				$value =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
				$outQuery .= "&key=$value";
			}
		}
		&nres($outQuery, "");
	}elsif($omsgid =~ /mode=20/){		# 文字列検索
		&nres($omsgid, "");
	}elsif($omsgid =~ /^mode=06/){				# 時間別番組表
		$omsgid =~ /sdate=([0-9]*)/; $tmpD = $1;
		&ttnres($omsgid, $tmpD);
		$ntim = substr($tmpD, 0, 4) . '年' . substr($tmpD, 4, 2) . '月' . substr($tmpD, 6, 2) . '日';
		$ntim .= 'の番組表<br><a href="?"><span style="font-size:9pt;">現在放送中の番組表へ</span></a>';
		&select();
	}elsif($omsgid =~ /^site/){	#IEPGから切り出して表示
		if($omsgid =~ /template=detail/){
			$omsgid = &get_iepgURL($omsgid);
		}
#print "content-type: text/html\n\n";
#print $omsgid;
#exit();
		&get_iepg($omsgid);
		if($chan ne ""){
			$msgid = $omsgid;
			$request = $YearI . $MonI . $DatI . '-' . $StatI . '-' . $EndI . '-' . $chan;
			$btsname = $mp4_folder . "\\" . $request;
			$errname = $log_folder."\\".$request.".err";
			&streamdisp();
		}else{
			&htmlhead();
			print "IEPG Error!";
		}
	}else{						# 検索画面
		&ttnres("mode=06&site=032&lhour=2&area=$my_area&category=$tcategory&template=program",'none');
		$ntim .= '現在放送中の番組表';
		&select();
	}
	print "</body></HTML>";
	exit();
}

$request = $day."-".$st_tim."-".$ed_tim."-".$ch;
$btsname = $mp4_folder . "\\" . $request;
$errname = $log_folder."\\".$request.".err";
foreach $statmp (@iepg_chan){	# 放送局逆引き
	($m_ch, $dsta) = split(/:/, $statmp);
	if($m_ch eq $ch){
		@dstac = split(/\,/, $dsta);
		$sta = $dstac[0];
		last;
	}
}

if($mode =~ /abort/){	#エンコード処理中断
	open(ABT, ">$btsname.abt"); close(ABT);
	sleep(3);
	$omsgid =~ /abort=(.*)$/; $URI = '?' . $1;
	&logdisp();
}

unless($mode =~ /make/){	#MP4生成ではない
	&streamdisp();
}

$yy = substr($day,0,2); $mm = substr($day,2,2); $dd = substr($day,4,2);
$stday = "$yy/$mm/$dd";
$h = substr($st_tim,0,2); $m = substr($st_tim,2,2); $s = substr($st_tim,4,2);
$stim = "$h:$m:00";
$h = substr($ed_tim,0,2); $m = substr($ed_tim,2,2); $s = substr($ed_tim,4,2);
$etim = "$h:$m:00";

$|=1;
unless((-f "$errname") || (($mode =~ /makep/) && (-f "$btsname.mp4")) || (($mode =~ /make/) && (-f "$btsname$RwIPOD.mp4"))){
	unless(-f "$btsname.np"){
		unless(-f "$btsname.np99"){	# 順番待ち
			&htmlhead();
			print "<BODY>";
			print "<script>location.href='?$omsgid';</script>\n\n\n\n\n</body></html>";
			$PofPerl = $^X;
			if($mode =~ /makep/){
				$MkMode= 0;
			}else{
				$MkMode= 1;
			}
			Win32::Process::Create($ProcessObj, $PofPerl,"$PofPerl encode.pl $btsname $errname $stday $stim $etim $ch $MkMode", 0, DETACHED_PROCESS, ".");
			exit();
		}else{
			&logdisp("■他の番組を抽出中です。順番待ちをしています&nbsp;<a href='?$request&abort=$omsgid'>「中断」</a>");
		}
	}else{
		$Rmsg = &status_vs($btsname);
		&logdisp($Rmsg);
	}
}else{
	$Rmsg = &status_vs($btsname);
	if($Rmsg ne ""){
		&logdisp($Rmsg);
	}
	$omsgid =~ /make[p]*=(.*)$/; $URI = '?' . $1;
	&logdisp();
}

# ---------------------
sub status_vs {
	local($btsname, $sw) = @_;
	$retval = "";

	if(-f "$btsname.np98"){	#TS切り出し中
		$fiszts = (-s "$btsname.ts");
		$fiszts = int($fiszts / 1024 / 1024);
		$retval = "■ TSを抽出中です。<br>おまちください..<br>(TS/$fiszts\MBytes)";
	}elsif(-f "$btsname.np11"){
		$retval = "■ PC向け最終処理発行中です。<br>おまちください...";
	}elsif(-f "$btsname.np1"){
		$retval = "■ iPod向け最終処理発行中です。<br>おまちください...";
	}elsif(-f "$btsname.np2"){
		$fiszts = (-s "$btsname.wav");
		$fiszts = int($fiszts / 1024 / 1024);
		$retval = "■ iPod向けエンコード処理中です。<br>おまちください...<br>(音声/dec, WAV/$fiszts\MBytes)";
	}elsif(-f "$btsname.np21"){
		$fiszts = (-s "$btsname.aactmp");
		$fiszts = int($fiszts / 1024 / 1024);
		$retval = "■ iPod向けエンコード処理中です。<br>おまちください...<br>(音声/enc, AAC/$fiszts\MBytes)";
	}elsif(-f "$btsname.np22"){
		$fiszts = (-s "$btsname$RwIPOD.mp4");
		$fiszts = int($fiszts / 1024 / 1024);
		$retval = "■ iPod向けエンコード処理中です。<br>おまちください...<br>(映像/mrg, MP4/$fiszts\MBytes)";
	}elsif(-f "$btsname.np3"){
		$fiszor = (-s "$btsname.mp4");
		$fiszoj = (-s "$btsname$RwIPOD.mp4");
		$finp = int($fiszoj / $fiszor * 100);
		$retval = "■ iPod向けエンコード処理中です。<br>おまちください...<br>(映像/enc, PC用比/$finp\%)";
	}elsif(-f "$btsname.np4"){
		if(-f $btsname . "_tmp.mp4"){
			$fiszts = (-s $btsname . "_tmp.mp4");
			$fiszts = int($fiszts / 1024 / 1024);
			$pgm = "<br>(tmp/$fiszts\MBytes)";
		}elsif(-f $btsname . ".mp4"){
			$fiszor = (-s "$btsname.ts");
			$fiszoj = (-s "$btsname.mp4");
			$finp = int($fiszoj / $fiszor * 100);
			$pgm = "<br>(TS比/$finp\%)";
		}else{
			$pgm = "";
		}
		$retval = "■ TSをMP4に変換中です。<br>おまちください...$pgm";
	}
	if($retval ne ""){
		if($omsgid =~ /make[p]*=(.*)$/){
			$URIL = $1;
		}else{
			$URIL = $omsgid;
		}
		if($sw ne 'nouri'){
			$retval .= "&nbsp;<a href='?$request&abort=$URIL'><nobr>「中断」</nobr></a>";
		}
	}
	return $retval;

}

sub htmlhead {
	($vwid) = @_;
	if($vwid eq ""){ $vwid = 345; }
print "Content-type: text/html\n\n";
print <<"_EOD_";
<HTML>
<HEAD>
	<TITLE>TV:$request</TITLE>
_EOD_

	if(($brtype eq 1) || ($brtype eq 6) || ($brtype eq 8)){	# ipod, Opera mobile 9.5, WM iris.
		print "<meta name='viewport' content='width=$vwid' />\n";
	}
print <<"_EOD_";
	<meta http-equiv="Content-type" content="text/html; charset=utf-8">
	<style type="text/css">
	img {
	text-decoration: none;
	background: transparent;
	border: 0px none;
	vertical-align: bottom;
	}
	A { text-decoration:none;}
	A:hover { text-decoration:underline;}
	.nres {
		font-size: 9pt;
		line-height:1.2	;
	}
	.ttbl table {
		font-size: 9pt;
		table-layout:fixed;
		width:100%;
		border-collapse:collapse;
		border:1px solid #999999;
	}
	.ttbl td {
		border:1px solid #999999;
		overflow:hidden;
		vertical-align:top;
		line-height:1.2	;
	}
	.ttbl th {
		background-color: #CCE9FF;
		border:1px solid #999999;
		overflow:hidden;
		line-height:1.2	;
	}
	.anime {
		background-color: #FDFDE2;
	}
	.dorama {
		background-color: #FDEEF1;
	}
	.sports {
		background-color: #DEFEEB;
	}
	.movie {
		background-color: #FDE8CF;
	}

	</style>
</HEAD>
_EOD_
}

# ---------------------
#   ログ表示
# ---------------------
sub logdisp {
	my $msg = shift;

	print "Content-type: text/html\n\n";
	print <<_EOD_;
<HTML>
<HEAD>
_EOD_
	if($URI ne ""){
		print "<META http-equiv='refresh' content='0;url=$URI'>\n";
	}else{
		print "<META http-equiv='refresh' content='$reload_time'>\n"
	}
	if(($brtype eq 1) || ($brtype eq 6) || ($brtype eq 8)){	# ipod, Opera mobile 9.5, WM iris.
		print "<meta name='viewport' content='width=320' />\n";
	}
	print <<_EOD_;
	<meta http-equiv="Content-type" content="text/html; charset=utf-8">
	<TITLE>TV:$request</TITLE>
</HEAD>
<BODY>
	$msg<BR>
</BODY>
</HTML>
_EOD_
	exit(0);
}


# ---------------------
#   動画ページ表示
# ---------------------
sub streamdisp {
	if($omsgid =~ /down/){
			&streamdown;
	}else{
		if(($brtype eq 1) || ($brtype eq 6) || ($brtype eq 8)){	# ipod, Opera mobile 9.5, WM iris.
			&streamdisp_mobile;
		}else{
			if($OpenNewWindow eq 0){
				&streamdisp_pc;
			}else{
				&streamdisp_pcwo;
			}
		}
	}
}

sub streamdisp_mobile {
	$recok = &jg_recdate($request);
	if(($ShotE eq 1) && (-f $FFMpeg) && ($recok eq 1)){
		&get_shot($request);
	}
	&htmlhead();
	print <<"_EOD_";
<BODY>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style='font-size: 9pt;' id='mtbl'>
<tr><td bgcolor="#EEAAAA"><table border=0 cellpadding=0 cellspacing=0 width=100% style="font-size: 9pt;"><td>■
_EOD_
	if($sta ne ""){ print "$sta &nbsp;" }
	if($TitleI ne ""){ print "「$TitleI」"; }
	print "</td><td>&nbsp;</td><td align=right nowrap>\n";
	if($OpenNewWindow eq 0){
		print "<a href='?'>番組検索へ戻る</a>";
	}
	print <<"_EOD_";
</table></td></tr><tr><td>
_EOD_
	if($recok eq 1){
		if(-f "$ShotDir\\$request.jpg"){
			print "<img src='$jpg_URL$request.jpg'>\n";
		}else{
			print "<table border=0 width=320 height=180><td bgcolor='#000000'></td></table>";
		}
	}else{
		print "<table border=0 width=320 height=180><td bgcolor='#555555' align=center><font color='#ffffff'>録画が完了していない為、再生できません</font></td></table>";
	}
	print "<table border=0><td></td></table>\n";
	$bsTbl = "<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style='font-size: 9pt;' width=100%><tr><td bgcolor='#EECCCC'>";
 	if($TitleSI ne ""){ print "$bsTbl $TitleSI <br></td></table>";}
	if(($TitleSI ne "") && ($TitleSP ne "")){ print "<table border=0><td></td></table>\n"; } 
	if($TitleSP ne ""){ print "$bsTbl $TitleSP <br></td></table>";}
	print "<table border=0><td></td></table><table border=0 style='font-size: 9pt;'><td align=center>\n";
	$TitleIEnc = &mkFname($TitleI, $request, $sta);
	$Rmsg = &status_vs($btsname);
	($tmp1, $tmp2, $tmp3, $cht) = split(/-/, $request);
	if(-f "$errname"){
		print "■MP4作成に失敗しました";
	}elsif(-f "$btsname.np99"){
		print "■他の番組を抽出中です。順番待ちをしています&nbsp;<a href='?$request&abort=$omsgid'><nobr>「中断」</nobr></a>";
	}elsif($Rmsg ne ""){
		print $Rmsg;
	}elsif($recok eq -1){
		print "■現在録画中です";
	}elsif($recok eq -2){
		print "■まだ録画していません";
	}else{
		if((-f "$btsname$RwIPOD.mp4") && ($brtype eq 1)){
			$fisz = (-s "$btsname$RwIPOD.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "・MP4ファイルサイズ ($fisz MB)<br>";
			print "<nobr>&nbsp;&nbsp;&nbsp;<a href='download.pl?$request.mp4&$request$RwIPOD%2Emp4&$RwIPOD&oct'>ダウンロード</a>";
			print "&nbsp;&nbsp;&nbsp;<a href='$mp4_URL$request$RwIPOD.mp4'>MP4を再生する</a>";
		}elsif((-f "$btsname.mp4") && ($brtype eq 1)){
			$fisz = (-s "$btsname.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "・MP4ファイルサイズ ($fisz MB)<br>";
			print "<nobr>&nbsp;&nbsp;&nbsp;<a href='download.pl?$request.mp4&$request%2Emp4&&oct'>ダウンロード</a>";
			print "&nbsp;&nbsp;&nbsp;<a href='$mp4_URL$request.mp4'>MP4を再生する</a>";
		}elsif((-f "$btsname.mp4") && (($brtype eq 6) || ($brtype eq 8))){	# Opera Mobile, Iris
			$fisz = (-s "$btsname.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "・MP4ファイルサイズ ($fisz MB)<br>";
			print "<nobr>&nbsp;&nbsp;&nbsp;<a href='download.pl?$request.mp4&$TitleIEnc%2Emp4'>ダウンロード</a>";
			print "<nobr>&nbsp;&nbsp;&nbsp;<a href='download.pl?$request.bat&$request%2Emp4'>MP4を再生する</a>";
		}elsif(-f "$errname"){
			print "・MP4作成に失敗しました";
		}else{
			if(($brtype eq 1) && ($iencM{$cht} ne 0)){
				print "・<a href='?$request&make=$msgid'>MP4を作成</a>";
			}else{
				print "・<a href='?$request&makep=$msgid'>MP4を作成</a>";
			}
		}
	}
	print <<"_EOD_";
</td>
</table>
</div></td></tr></table>
</form>
</BODY>
</HTML>

_EOD_
	exit(0);
}

sub streamdisp_pc {
	$recok = &jg_recdate($request);
	if(($ShotE eq 1) && (-f $FFMpeg) && ($recok eq 1)){
		&get_shot($request);
	}
	&htmlhead();
	print <<"_EOD_";
<body>
<SCRIPT TYPE="text/javascript">
	function scale_chg(scid) {
		document.cookie  ="scgID=" + scid;
		location.href = "?$msgid"
	}
	var PgTmp = document.cookie;
	if(PgTmp == ""){ PgTmp = "scgID=1"; }
	PgTal = PgTmp.split("=");
	if(PgTal[1] == 3){
		var xw = 640;
		var yh = 380;
	}else if(PgTal[1] == 2){
		var xw = 480;
		var yh = 290;
	}else{
		var xw = 320;
		var yh = 200;
	}
	function playerReady(obj) {
		player = document.getElementById(obj['id']);
//		player.addControllerListener('ITEM', 'itemtest');
//		player.addModelListener('META', 'metatest');
		player.addModelListener('TIME', 'ntime');
	}
	function ntime(obj) { nowpos = obj.position; }

	function seekmv(dftime) {
		player.sendEvent('SEEK', nowpos + dftime);
	}


</script>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style='font-size: 9pt;' id='mtbl'>
<tr><td bgcolor="#EEAAAA"><table border=0 cellpadding=0 cellspacing=0 width=100% style="font-size: 9pt;"><td>■
_EOD_
	if($sta ne ""){ print "$sta &nbsp;" }
	if($TitleI ne ""){ print "「$TitleI」"; }
	print "</td><td>&nbsp;</td><td align=right nowrap>\n";
	if($OpenNewWindow eq 0){
		print "<a href='?'>番組検索へ戻る</a>";
	}
	print <<"_EOD_";
</td>
</table></td></tr><tr><td align=center>
_EOD_

	if($recok ne -2){
		print <<"_EOD_";
<form name='chgs'>
<script type="text/javascript" src="swfobject.js"></script>
<div id='preview'>This div will be replaced</div>
<script type="text/javascript">
	var s1 = new SWFObject('player44.swf','player', xw, yh,'9','#ffffff');
	s1.addParam('allowfullscreen','true');
	s1.addParam('allowscriptaccess','always');
_EOD_
		if($Caption eq 0){
			if(-f "$ShotDir\\$request.jpg"){
				print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&image=$jpg_URL$request.jpg&type=rtmp');\n";
			}else{
				print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&type=rtmp');\n";
			}
		}else{
			print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&plugins=captions-1&captions.file=caption.pl?file=$request.xml');\n"
		}
		print <<"_EOD_";
	s1.write('preview');
	document.write("<table border=0 width=100%><td bgcolor='#EECCCC' align=center>");
	document.write("<div style='font-size:9pt;'>画面サイズ変更：");
	document.write("<input name='r1' type='button' value='x1' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 1){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(1);'>");
	}
	document.write("<input name='r2' type='button' value='x1.5' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 2){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(2);'>");
	}
	document.write("<input name='r3' type='button' value='x2' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 3){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(3);'>");
	}
</script>
</table>
<table border=0 width=100%>
<td bgcolor='#EE9999' align=center>
<input type="button" name="ds15" onclick="seekmv(-10);" value="-10秒" style='width:50px;font-size:9pt;'>
<input type="button" name="ST" onclick="player.sendEvent('STOP', true);" value="停止" style='width:45px;font-size:9pt;'>
<input type="button" name="pl" onclick="player.sendEvent('PLAY', true);" value="再生" style='width:45px;font-size:9pt;'>
<input type="button" name="s15" onclick="seekmv(10);" value="+10秒" style='width:50px;font-size:9pt;'>
<input type="button" name="s30" onclick="seekmv(30);" value="+30秒" style='width:50px;font-size:9pt;'>
<input type="button" name="cms" onclick="seekmv($CMSt);" value="CM送" style='width:50px;font-size:9pt;'>
</td>
</table>
_EOD_
	}else{
		print "<table border=0 width=320 height=180><td bgcolor='#555555' align=center><font color='#ffffff'>未来の番組は再生できません</font></td></table>";
	}
	print "<table border=0><td></td></table>";
	$bsTbl = "<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style='font-size: 9pt;' width=100%><tr><td bgcolor='#EECCCC'>";
	if($TitleSI ne ""){ print "$bsTbl $TitleSI <br></td></table>";}
	if(($TitleSI ne "") && ($TitleSP ne "")){ print "<table border=0><td></td></table>\n"; } 
	if($TitleSP ne ""){ print "$bsTbl $TitleSP <br></td></table>";}
	print "<table border=0><td></td></table><table border=0  cellpadding=0 cellspacing=2 style='font-size: 9pt;'><tr align=center valign=top><td>\n";
	$TitleIEnc = &mkFname($TitleI, $request, $sta);
	$Rmsg = &status_vs($btsname);
	($tmp1, $tmp2, $tmp3, $cht) = split(/-/, $request);
	if(-f "$errname"){
		print "■MP4作成に失敗しました<br>・<a href='download.pl?$request.ts&$TitleIEnc%2Ets'>TS Down</a>";
	}elsif(-f "$btsname.np99"){
		print "■他の番組を抽出中です。順番待ちをしています&nbsp;<a href='?$request&abort=$omsgid'><nobr>「中断」</nobr></a>";
	}elsif($Rmsg ne ""){
		print $Rmsg;
	}elsif($recok eq -1){
		print "■現在録画中です";
	}elsif($recok eq -2){
		print "■まだ録画していません";
	}else{
		if(-f "$btsname.mp4"){
			$fisz = (-s "$btsname.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc%2Emp4'>PC用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
		}else{
			print "・<a href='?$request&makep=$msgid'>PC用MP4作成</a>";
		}
		if($RwIPOD ne ""){
			print "</td><td width=5>&nbsp;</td><td>";
			if(-f "$btsname$RwIPOD.mp4"){
				$fisz = (-s "$btsname$RwIPOD.mp4");
				$fisz = int($fisz / 1024 / 1024);
				print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc$RwIPOD%2Emp4&$RwIPOD'>iPod用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
			}elsif((-f "$btsname.mp4") && ($iencM{$cht} eq 0)){
				$fisz = (-s "$btsname.mp4");
				$fisz = int($fisz / 1024 / 1024);
				print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc$RwIPOD%2Emp4'>iPod用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
			}elsif($iencM{$cht} eq 0){
				print "・<a href='?$request&makep=$msgid'>iPod用MP4作成</a>";
			}else{
				print "・<a href='?$request&make=$msgid'>iPod用MP4作成</a>";
			}
		}
		print <<"_EOD_";
</td><td width=5>&nbsp</td>
</td><td align=right nowrap>・<a href='download.pl?$request.ts&$TitleIEnc%2Ets'>TS Down</a></td>
_EOD_
		if($MP4Archiver eq 1){
			print <<"_EOD_";
</td><td width=5>&nbsp;</td>
<td align=right nowrap>・<a href='caption2.pl?file=$request.xml'>字幕生成</a></td>
_EOD_
		}
print "</tr>";
	}
	print <<"_EOD_";
</table>
</div></td></tr></table>
</form>
<script type="text/javascript">
document.getElementById('mtbl').style.width=xw + 14;
</script>
</BODY>
</HTML>

_EOD_
	exit(0);
}


sub streamdisp_pcwo {
	$recok = &jg_recdate($request);
	if(($ShotE eq 1) && (-f $FFMpeg) && ($recok eq 1)){
		&get_shot($request);
	}
	&htmlhead();
	if($brtype eq 2){		#Chrome
		$hA = 70;
		$xA = 16;
	}elsif($brtype eq 3){	#FireFox
		$hA = 95;
		$xA = 16;
	}elsif($brtype eq 4){	#IE
		$hA = 90;
		$xA = 10;
	}elsif($brtype eq 5){	#opera
		$hA = 85;
		$xA = 18;
	}else{
		$hA = 90;
		$xA = 15;
	}
	print <<"_EOD_";
<body marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0 OnLoad="resizewin();">
<center>
<SCRIPT TYPE="text/javascript">
	window.resizeTo(320,240);
	window.moveTo(0,0);
	var PgTmp = document.cookie;
	if(PgTmp == ""){ PgTmp = "scgID=1"; }
	PgTal = PgTmp.split("=");
	if(PgTal[1] == 3){
		var xw = 640;
		var yh = 380;
	}else if(PgTal[1] == 2){
		var xw = 480;
		var yh = 290;
	}else{
		var xw = 320;
		var yh = 200;
	}

	function playerReady(obj) {
		player = document.getElementById(obj['id']);
//		player.addControllerListener('ITEM', 'itemtest');
//		player.addModelListener('META', 'metatest');
		player.addModelListener('TIME', 'ntime');
	}
	function ntime(obj) { nowpos = obj.position; }

	function seekmv(dftime) {
		player.sendEvent('SEEK', nowpos + dftime);
	}

	function scale_chg(scid) {
		window.resizeTo(320,240);
		document.cookie  ="scgID=" + scid;
		location.href = "?$msgid"
	}

	function resizewin() {
		var yhi = document.body.scrollHeight;
		window.resizeTo(xw + $xA, yhi + $hA);
		window.focus();
	}

	document.write("<table border=0 cellpadding=3 cellspacing=0 width=" + xw + " style='font-size: 9pt;'><tr bgcolor='#EEAAAA'><td>■");
</script>
_EOD_
	if($sta ne ""){ print "$sta &nbsp;" }
	if($TitleI ne ""){ print "「$TitleI」"; }
	print <<"_EOD_";
</td><td width=5><form name='chgs'></td></tr>
</table>
_EOD_
	if($recok ne -2){
		print <<"_EOD_";
<script type="text/javascript" src="swfobject.js"></script>
<div id='preview'>This div will be replaced</div>
<script type="text/javascript">
	var s1 = new SWFObject('player44.swf','player', xw, yh, '9','#ffffff');
	s1.addParam('allowfullscreen','true');
	s1.addParam('allowscriptaccess','always');
_EOD_
		if($Caption eq 0){
			if(-f "$ShotDir\\$request.jpg"){
				print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&image=$jpg_URL$request.jpg');\n";
			}else{
				print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true');\n";
			}
		}else{
			print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&plugins=captions-1&captions.file=caption.pl?file=$request.xml');\n"
		}
		print <<"_EOD_";


		print <<"_EOD_";
	s1.write('preview');
	document.write("<table border=0 width=" + xw + "><td bgcolor='#EECCCC' align=center>");
	document.write("<div style='font-size:9pt;'>画面サイズ変更：");
	document.write("<input name='r1' type='button' value='x1' style='width:50px;font-size:9pt;' ");
  	if(PgTal[1] == 1){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(1);'>");
	}
	document.write("<input name='r2' type='button' value='x1.5' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 2){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(2);'>");
	}
	document.write("<input name='r3' type='button' value='x2' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 3){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(3);'>");
	}
	document.write("</table><table border=0 width=" + xw + ">");

</script>
<td bgcolor='#EE9999' align=center>
<input type="button" name="ds15" onclick="seekmv(-10);" value="-10秒" style='width:50px;font-size:9pt;'>
<input type="button" name="ST" onclick="player.sendEvent('STOP', true);" value="停止" style='width:40px;font-size:9pt;'>
<input type="button" name="pl" onclick="player.sendEvent('PLAY', true);" value="再生" style='width:40px;font-size:9pt;'>
<input type="button" name="s15" onclick="seekmv(10);" value="+10秒" style='width:50px;font-size:9pt;'>
<input type="button" name="s30" onclick="seekmv(30);" value="+30秒" style='width:50px;font-size:9pt;'>
<input type="button" name="cms" onclick="seekmv($CMSt);" value="CM送" style='width:50px;font-size:9pt;'>
</td>
</table>
_EOD_
	}else{
		print "<table border=0 width=320 height=180><td bgcolor='#555555' align=center><font color='#ffffff'>未来の番組は再生できません</font></td></table>";
	}
	print "<table border=0><td></td></table>";
	$bsTbl = "<script>document.write(\"<table border=0 cellspacing=0 cellpadding=3 style='font-size: 9pt;' width=\" + xw +\"><tr><td bgcolor='#EECCCC'>\");</script>\n";
	if($TitleSI ne ""){ print "$bsTbl $TitleSI <br></td></table>";}
	if(($TitleSI ne "") && ($TitleSP ne "")){ print "<table border=0><td></td></table>\n"; } 
	if($TitleSP ne ""){ print "$bsTbl $TitleSP <br></td></table>";}
	print "<table border=0><td></td></table><table border=0 style='font-size: 9pt;'><td align=center>\n";
	$TitleIEnc = &mkFname($TitleI, $request, $sta);
	print "<table border=0><td></td></table><table border=0 cellpadding=0 cellspacing=2 style='font-size: 9pt;'><tr align=center valign=top><td>\n";
	$TitleIEnc = &mkFname($TitleI, $request, $sta);
	$recok = &jg_recdate($request);
	$Rmsg = &status_vs($btsname);
	($tmp1, $tmp2, $tmp3, $cht) = split(/-/, $request);
	if(-f "$errname"){
		print "■MP4作成に失敗しました<br>・<a href='download.pl?$request.ts&$TitleIEnc%2Ets'>TS Down</a>";
	}elsif(-f "$btsname.np99"){
		print "■他の番組を抽出中です。順番待ちをしています&nbsp;<a href='?$request&abort=$omsgid'><nobr>「中断」</nobr></a>";
	}elsif($Rmsg ne ""){
		print $Rmsg;
	}elsif($recok eq -1){
		print "■現在録画中です";
	}elsif($recok eq -2){
		print "■まだ録画していません";
	}else{
		if(-f "$btsname.mp4"){
			$fisz = (-s "$btsname.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc%2Emp4'>PC用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
		}else{
			print "・<a href='?$request&makep=$msgid'>PC用MP4作成</a>";
		}

		if($RwIPOD ne ""){
			print "</td><td width=5>&nbsp;</td><td>";
			if(-f "$btsname$RwIPOD.mp4"){
				$fisz = (-s "$btsname$RwIPOD.mp4");
				$fisz = int($fisz / 1024 / 1024);
				print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc$RwIPOD%2Emp4&$RwIPOD'>iPod用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
			}elsif((-f "$btsname.mp4") && ($iencM{$cht} eq 0)){
				$fisz = (-s "$btsname.mp4");
				$fisz = int($fisz / 1024 / 1024);
				print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc$RwIPOD%2Emp4'>iPod用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
			}elsif($iencM{$cht} eq 0){
				print "・<a href='?$request&makep=$msgid'>iPod用MP4作成</a>";
			}else{
				print "・<a href='?$request&make=$msgid'>iPod用MP4作成</a>";
			}
		}
		print <<"_EOD_";
</td><td width=5>&nbsp</td>
</td><td align=right nowrap>・<a href='download.pl?$request.ts&$TitleIEnc%2Ets'>TS Down</a></td>
_EOD_
		if($MP4Archiver eq 1){
			print <<"_EOD_";
</td><td width=5>&nbsp;</td>
<td align=right nowrap>・<a href='caption2.pl?file=$request.xml'>字幕生成</a></td>
_EOD_
		}
print "</tr>";
	}
print <<"_EOD_";
</td></tr>
</table>
</div></td></tr></table>
</form>
</BODY>
</HTML>

_EOD_
	exit(0);
}

# ---------------------
#   選択ページ表示
# ---------------------

sub select {
	&htmlhead("960");
	if($jsib eq 1){
		print "<BODY onLoad=\"setDateF();setDate();setGraph(dat);\">\n";
	}else{
		print "<BODY onLoad=\"setDateF();setDate();\">\n";
	}
	print <<_EOD_;
	<SCRIPT TYPE="text/javascript"> 
<!-- 
	var youbi = new Array("日","月","火","水","木","金","土");

	function setDateF() {
		var today,dat,i,y,m,d,c;
		document.req.Day.length = $start_date;
		today = new Date();
		for(i=0;i<$start_date;i++) {
			dat = new Date();
			dat.setDate(today.getDate()-i);
			y = ("0"+dat.getYear().toString()); y = y.substr(y.length-2,2);
			m = ("0"+(dat.getMonth()+1).toString()); m = m.substr(m.length-2,2);
			d = ("0"+dat.getDate().toString()); d = d.substr(d.length-2,2);
			b = youbi[dat.getDay()];
			document.req.Day.options[i].text  = '20'+y+'/'+m+'/'+d+'('+b+')';
			document.req.Day.options[i].value = y+m+d;
		}
	}

	function goPlay() {
		var req,h,h1,h2,st_h,st_m,ed_h,ed_m,today,bef,day,y,m,d,sh,sm,eh,em;
		
		today = new Date();
		if (document.req.Back.value == '') {
			st_h = (document.req.Hour.value-0);
			st_m = (document.req.Min.value-0);
			ed_h = (document.req.Hour2.value-0);
			ed_m = (document.req.Min2.value-0);
			day  = document.req.Day.value;
		} else {
			bef = new Date();
			bef.setMinutes(today.getMinutes()-(document.req.Back.value-0));
			st_h = bef.getHours();
			st_m = bef.getMinutes();
			ed_h = today.getHours();
			ed_m = today.getMinutes();
			y = ("0"+bef.getYear().toString()); y = y.substr(y.length-2,2);
			m = ("0"+(bef.getMonth()+1).toString()); m = m.substr(m.length-2,2);
			d = ("0"+bef.getDate().toString()); d = d.substr(d.length-2,2);
			day  = y+m+d;
		}
		sh = ("0"+st_h.toString()); sh = sh.substr(sh.length-2,2);
		sm = ("0"+st_m.toString()); sm = sm.substr(sm.length-2,2);
		eh = ("0"+ed_h.toString()); eh = eh.substr(eh.length-2,2);
		em = ("0"+ed_m.toString()); em = em.substr(em.length-2,2);

		h1 = st_h*60+st_m;
		h2 = ed_h*60+ed_m;
		if (h1 == h2) {
			alert("開始時間と終了時間が同一です");
			return false;
		}
		h = h2 - h1;
		if (h<0) { h += 24*60; }
		if (h>(3*60)) {
			alert("一度の抽出時間は３時間までにしてください");
			return false;
		}
_EOD_
	if($OpenNewWindow eq 1){
		print "	req = '" . $cginame. "\?'+day+'-'+sh+sm+'00-'+eh+em+'00-'+document.req.Channel.value;\n";
		print "var wo = window.open(req, 'view_w', 'toolbar=no,directories=no,scrollbars=no,resizable=no,menubar=no,width=320,height=240');wo.resizeTo(320,240);wo.focus();\n";
	}else{
		print "	req = day+'-'+sh+sm+'00-'+eh+em+'00-'+document.req.Channel.value;\n";
		print "location.search = req;\n";
	}
	print <<_EOD_;
		return false;
	}

	function dispDate() {
		var dnum,dir,dat,dat2,y,m,d;

		dnum = document.days.Period.options[document.days.Period.selectedIndex].value;
		dat = new Date();
		dat.setTime(document.days.Day.options[document.days.Day.selectedIndex].value);
		dat2 = new Date();
		dat2.setTime(document.days.Day.options[document.days.Day.selectedIndex].value);
		if(dir==0) {
			dat.setDate(dat.getDate()-dnum);
		} else {
			dat2.setDate(dat2.getDate()+eval(dnum));
		}
		y = dat.getYear(); if(y < 1900){ y += 1900; }
		y = ("0"+y.toString()); y = y.substr(y.length-4,4);
		m = ("0"+(dat.getMonth()+1).toString()); m = m.substr(m.length-2,2);
		d = ("0"+dat.getDate().toString()); d = d.substr(d.length-2,2);
		document.days.SDate.value = y+m+d;

		y = dat2.getYear(); if(y < 1900){ y += 1900; }
		y = ("0"+y.toString()); y = y.substr(y.length-4,4);
		m = ("0"+(dat2.getMonth()+1).toString()); m = m.substr(m.length-2,2);
		d = ("0"+dat2.getDate().toString()); d = d.substr(d.length-2,2);
		document.days.EDate.value = y+m+d;

	}

	function setDate() {
		var today,dat,i,y,m,d,b;
		document.days.Day.length = $start_date;
		today = new Date();
		for(i=0;i<$start_date;i++) {
			dat = new Date();
			dat.setDate(today.getDate()-i);
			y = dat.getYear(); if(y < 1900){ y += 1900; }
			y = ("0"+y.toString()); y = y.substr(y.length-4,4);
			m = ("0"+(dat.getMonth()+1).toString()); m = m.substr(m.length-2,2);
			d = ("0"+dat.getDate().toString()); d = d.substr(d.length-2,2);
			b = youbi[dat.getDay()];
			document.days.Day.options[i].text  = y+'/'+m+'/'+d+'('+b+')';
			document.days.Day.options[i].value = dat.getTime();
		}
		dispDate();
	}

	function goNikkan2() {
		var code,genre,first,i,dnum,area,url;
_EOD_
  	if($TTSrhE eq 0){
		print <<_EOD_;
		code = new Array("B.","C.","D.","E.","F.","G.","H.","I.","J.","K.","L.","M.","BA","BB","BC","CA","CB","CC","DE","D2","D1","D4","D3","DI","EB","EA","ED","FA","FB","FE","FF","FG","FH","G1","G2","G3","HA","HB","HD","HE","HI","HJ","IA","IB","IC","JA","JB","JD","JE","JH","JI","KA","KF","KH","MA","MB","MC");
_EOD_
	}else{
		print <<_EOD_;
		code = new Array("B.","C.","D.","E.","F.","G.","H.","I.","J.","K.","L.","M.");
_EOD_
	}
	print <<_EOD_;
		first = true;
		genre = "";
		for(i=0;i<code.length;i++) {
			if( document.gens.elements["myCHK"+i].checked ) {
				if(first) {
					first = false;
				} else {
					genre += "|";
				}
				genre += code[i];
			}
		}

		dnum = eval(document.days.Period.options[document.days.Period.selectedIndex].value)-1;
		area = ("00"+"$my_area"); area = area.substr(area.length-3,3);
		url = "?mode=20&site=032&sort=d&sdate="+document.days.SDate.value+"&shour=05&lhour=24&area="+area+"&ldate="+dnum+"&genre="+genre+"&template=result&category=$category";
		location.href = url;
		return false;
	}

	function click_day(stday) {
		var area;
		area = ("00"+"$my_area"); area = area.substr(area.length-3,3);
		location.href="?mode=06&site=032&category=$tcategory&area=" + area + "&template=program&sdate=" + stday + "&lhour=24&shour=$startH";
	}
	function chkE(cobj) {
		var ce;
		eval("ce = document.gens." + cobj + ".checked;");
		if(ce == true){
			eval("document.gens." + cobj + ".checked = false;");
		}else{
			eval("document.gens." + cobj + ".checked = true;");
		}
		return false;
	}
// -->
	</SCRIPT>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style="font-size: 9pt;" width=100%>
<tr><td bgcolor="#EEAAAA">■番組検索
_EOD_
	if($MP4Archiver eq 1){
		print "/<a href='./archives.pl'>mp4アーカイバ</a>";
	}

print <<_EOD_;
</td></tr>
<tr><td>
<br><b>・時間別番組表\から直接選択して抽出</b><br>
_EOD_

for($ci=1; $ci>-7; $ci--){
	$cVCal{$ci} = &MakeCal($ci);
}

$calDis = <<_EOS_;
<table border=0 width=100%>
<tr valign="top">
<td>$cVCal{-2}</td>
<td>$cVCal{-1}</td>
<td>$cVCal{0}</td>
<td>$cVCal{1}</td>
<td valign=middle align=center width=90% rowspan=2><span style='font-size:24pt;'>$ntim</span></td>
</tr>
<tr valign="top">
<td>$cVCal{'-6'}</td>
<td>$cVCal{'-5'}</td>
<td>$cVCal{'-4'}</td>
<td>$cVCal{'-3'}</td>
</tr>
</table>
_EOS_
	print $calDis;
	print $glbSO;
	if($MoreCal eq 1){ print $calDis; }
	print <<_EOD_;
<FORM NAME="req" onSubmit="return goPlay()" style="font-size:9pt;">
<hr>
<br><b>・時間を指定して番組抽出</b><br>
	<SELECT NAME="Day" style="font-size:9pt;">
	</SELECT>
	<SELECT NAME="Channel" style="font-size:9pt;">
_EOD_

	foreach $chanTmp (@iepg_chan){
		#&jcode'convert(*chanTmp, 'euc');
		($ChanObj, $stations) = split(/:/, $chanTmp);
		@stationS = split(/\,/, $stations);
		$station = shift(@stationS);
		#&jcode'convert(*station, 'sjis');
		print "<OPTION VALUE=\"$ChanObj\">$station</OPTION>\n";
	}
	print <<_EOD_;
	</SELECT>
	<SELECT NAME="Hour" style="font-size:9pt;">
		<OPTION VALUE="00">00</OPTION>
		<OPTION VALUE="01">01</OPTION>
		<OPTION VALUE="02">02</OPTION>
		<OPTION VALUE="03">03</OPTION>
		<OPTION VALUE="04">04</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="06">06</OPTION>
		<OPTION VALUE="07">07</OPTION>
		<OPTION VALUE="08">08</OPTION>
		<OPTION VALUE="09">09</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="11">11</OPTION>
		<OPTION VALUE="12">12</OPTION>
		<OPTION VALUE="13">13</OPTION>
		<OPTION VALUE="14">14</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="16">16</OPTION>
		<OPTION VALUE="17">17</OPTION>
		<OPTION VALUE="18">18</OPTION>
		<OPTION VALUE="19">19</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="21">21</OPTION>
		<OPTION VALUE="22">22</OPTION>
		<OPTION VALUE="23">23</OPTION>
	</SELECT>
	:
	<SELECT NAME="Min" style="font-size:9pt;">
		<OPTION VALUE="00">00</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="25">25</OPTION>
		<OPTION VALUE="30">30</OPTION>
		<OPTION VALUE="35">35</OPTION>
		<OPTION VALUE="40">40</OPTION>
		<OPTION VALUE="45">45</OPTION>
		<OPTION VALUE="50">50</OPTION>
		<OPTION VALUE="55">55</OPTION>
	</SELECT>
	～
	<SELECT NAME="Hour2" style="font-size:9pt;">
		<OPTION VALUE="00">00</OPTION>
		<OPTION VALUE="01">01</OPTION>
		<OPTION VALUE="02">02</OPTION>
		<OPTION VALUE="03">03</OPTION>
		<OPTION VALUE="04">04</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="06">06</OPTION>
		<OPTION VALUE="07">07</OPTION>
		<OPTION VALUE="08">08</OPTION>
		<OPTION VALUE="09">09</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="11">11</OPTION>
		<OPTION VALUE="12">12</OPTION>
		<OPTION VALUE="13">13</OPTION>
		<OPTION VALUE="14">14</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="16">16</OPTION>
		<OPTION VALUE="17">17</OPTION>
		<OPTION VALUE="18">18</OPTION>
		<OPTION VALUE="19">19</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="21">21</OPTION>
		<OPTION VALUE="22">22</OPTION>
		<OPTION VALUE="23">23</OPTION>
	</SELECT>
	:
	<SELECT NAME="Min2" style="font-size:9pt;">
		<OPTION VALUE="00">00</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="25">25</OPTION>
		<OPTION VALUE="30">30</OPTION>
		<OPTION VALUE="35">35</OPTION>
		<OPTION VALUE="40">40</OPTION>
		<OPTION VALUE="45">45</OPTION>
		<OPTION VALUE="50">50</OPTION>
		<OPTION VALUE="55">55</OPTION>
	</SELECT>
	を抽出、または今から
	<SELECT NAME="Back" style="font-size:9pt;">
		<OPTION VALUE="">--</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="25">25</OPTION>
		<OPTION VALUE="30">30</OPTION>
		<OPTION VALUE="35">35</OPTION>
		<OPTION VALUE="40">40</OPTION>
		<OPTION VALUE="45">45</OPTION>
		<OPTION VALUE="50">50</OPTION>
		<OPTION VALUE="55">55</OPTION>
	</SELECT>分前を
	<INPUT TYPE="submit" VALUE="探す！" style="font-size:9pt;">
</FORM>
<FORM NAME="days" style="font-size:9pt;" method="get" action="$cginame">
<hr>
<br>
<b>・番組表\から検索して抽出</b><br>
<table border=0 cellpadding=0 cellspacing=0 style="font-size:9pt;">
<td>
	<INPUT TYPE="hidden" NAME="mode" VALUE="10">
	<SELECT NAME="Day" onChange="dispDate()" style="font-size:9pt;">
	</SELECT>
から
	<SELECT NAME="Period" onChange="dispDate()" style="font-size:9pt;">
		<OPTION VALUE="-2" >3日間前</OPTION>
		<OPTION VALUE="-6" SELECTED>1週間前</OPTION>
		<OPTION VALUE="-13">2週間前</OPTION>
		<OPTION VALUE="-20">3週間前</OPTION>
		<OPTION VALUE="-27">4週間前</OPTION>
	</SELECT>
までの範囲を、キーワード
	<INPUT TYPE="hidden" NAME="SDate" READONLY>
	<INPUT TYPE="hidden" NAME="EDate" READONLY>
	<INPUT TYPE="text" NAME="Search" SIZE=20 style="font-size:9pt;">で<INPUT TYPE="submit" VALUE="検索" style="font-size:9pt;">
</td><td></FORM></td>
<td><FORM NAME="gens" onSubmit="return goNikkan2()" style="font-size:9pt;"></td>
</table>
	または、上記の日付の範囲で、以下のジャンルを<INPUT TYPE="submit" VALUE="抽出" style="font-size:9pt;"><br>
_EOD_

	if($TTSrhE eq 0){
		print <<_EOD_;
<table border=0 cellpadding=0 cellspacing=1 style="font-size:8pt;" width=620>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK5" ><B>バラエティ</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK33">バラエティ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK34">クイズ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK35">トーク</TD>
			</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK0" ><B>ドラマ</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK12">国内ドラマ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK13">海外ドラマ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK14">時代劇</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK1" ><B>映画</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK15">洋画</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK16">邦画</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK17">アニメ映画</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK7" ><B>アニメ・特撮</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK42">国内アニメ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK43">海外アニメ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK44">特撮・ヒーロー</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK11"><B>ドキュメンタリー</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK54">社会・時事</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK55">歴史・紀行</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK56">自然・動物・環境</TD>
		</TR>
		<TR>
			<TD ROWSPAN=2 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK6" ><B>趣味・教育</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK36">旅</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK37">釣り</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK38">科学</TD>
		</TR>
		<TR>
			<TD><INPUT TYPE="checkbox" NAME="myCHK39">歴史</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK40">車・オートバイ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK41">コンピュータ・TVゲーム</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK9" ><B>情報・ワイドショー</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK51">芸能\・ワイドショー</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK52">グルメ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK53">情報番組</TD>
		</TR>
		<TR>
			<TD ROWSPAN=2 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK8" ><B>ニュース・報道</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK45">定時総合ニュース</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK46">天気</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK47">経済・市況</TD>
		</TR>
		<TR>
			<TD><INPUT TYPE="checkbox" NAME="myCHK48">海外・国際</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK49">報道特番</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK50">ローカル・地域ニュース</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK3" ><B>劇場・公演</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK24">落語・演芸</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK25">歌舞伎・古典</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK26">ミュージカル</TD>
		</TR>
		<TR>
			<TD ROWSPAN=2 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK4" ><B>音楽</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK27">国内ロック・ポップス</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK28">海外ロック・ポップス</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK29">歌謡曲・演歌</TD>
		</TR>
		<TR>
			<TD><INPUT TYPE="checkbox" NAME="myCHK30">ライブ・コンサート</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK31">ランキング・リクエスト</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK32">カラオケ・のど自慢</TD>
		</TR>
		<TR>
			<TD ROWSPAN=2 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK2" ><B>スポーツ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK18">スポーツニュース</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK19">野球</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK20">サッカー</TD>
		</TR>
		<TR>
			<TD><INPUT TYPE="checkbox" NAME="myCHK21">相撲</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK22">ゴルフ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK23">競馬</TD>
		</TR>
		<TR>
			<TD colspan=4 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK10"><B>福祉</B></TD>
		</TR>
_EOD_
	}else{
		print <<_EOD_;
<table border=0 cellpadding=2 cellspacing=0 style="font-size:8pt;" width=100%>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD width=10><INPUT TYPE="checkbox" NAME="myCHK5"></TD>
			<TD OnClick='chkE("myCHK5");' width=99%><B>バラエティ</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK0"></TD>
			<TD OnClick='chkE("myCHK0");'><B>ドラマ</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK1"></TD>
			<TD OnClick='chkE("myCHK1");'><B>映画</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK7"></TD>
			<TD OnClick='chkE("myCHK7");'><B>アニメ・特撮</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK11"></TD>
			<TD OnClick='chkE("myCHK11");'><B>ドキュメンタリー</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK6"></TD>
			<TD OnClick='chkE("myCHK6");'><B>趣味・教育</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK9"></TD>
			<TD OnClick='chkE("myCHK9");'><B>情報・ワイドショー</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK8"></TD>
			<TD OnClick='chkE("myCHK8");'><B>ニュース・報道</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK3"></TD>
			<TD OnClick='chkE("myCHK3");'><B>劇場・公演</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK4"></TD>
			<TD OnClick='chkE("myCHK4");'><B>音楽</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK2"></TD>
			<TD OnClick='chkE("myCHK2");'><B>スポーツ</TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK10"></TD>
			<TD OnClick='chkE("myCHK10");'><B>福祉</B></TD>
		</TR>
_EOD_
	}
		print <<_EOD_;
</table>
</FORM>
</td></tr></table>

_EOD_
}

sub nres {
	local($msg, $mode) = @_;
	if($mode eq ""){
		$chnam = time;
	}else{
		$chnam = $mode;
	}
	if($CleanShot eq 1){	&expire_file($ThmDir, '*', 'nowlockT', $ExpireShot * 86400); }
	&expire_file($CacheDir, 'htm', 'CacheLockTimeT', $ExpireCacheT * 3600);
	$OCache = $CacheDir . "\\" . $chnam . '.htm';
	$resbuf = &read_cache($OCache, 'CacheLockTimeTS');
	if($resbuf eq ""){
		if($msg eq ""){
			&htmlhead();
			print "有効期限切れです\n";
			exit(0);
		}else{
			$ua = new LWP::UserAgent;
			$ua->agent("Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0)" . $ua->agent);
			if($Proxy ne ""){ $ua->proxy('http', $Proxy); }
			my $req = new HTTP::Request GET => $Server . '/tv.php?' . $msg;
			$req->referer($Server . '/tv.php');
			my $res = $ua->request($req); 
			if ($res->is_success) { 
				$resbuf = $res->content;
				if($chnam ne 'none'){
					&cache_write($resbuf, 'CacheLockTimeTS', $OCache);
				}
			}else{ 
				&htmlhead();
				print $res->status_line . "\n"; 
				exit(0);
			}
		}
	}
	$begstr = '<div id="result-table">';
	$engstr = '<div id="re-search">';

	$glblO = $glbSO = ""; $hitS = $nRecC = $jgh = 0;
	@execs =();
	$resbuf =~ s/\r\n/\n/sig;
	$resbuf =~ s/\r/\n/sig;
	foreach $RecS (split(/\n/, $resbuf)){
		if($RecS =~ /$begstr/){
			$hitS = 1;
		}elsif($RecS =~ /$engstr/){
			last;
		}elsif($hitS eq 1){ 
			$glbSO .= $RecS . "\n";
			if($RecS =~ /^[\s|\t]*<tr/){
				$IBUF = "";
				$NowCH = 0;
			}elsif($RecS =~ /[\s|\t]*<\/tr>/){
				$IBUF =~ s/\r|\n//g;
				$cols = 0;
				$IBUFs = "";
				foreach $tbljg (split(/\/td>/, $IBUF)){
					$tbljg =~ s/<td[^>]*>(.*)</$1/;
					$tbljg =~ s/^[\s]*//;
					if($cols eq 0){
						$IBUFs .= "<td>$tbljg"; $cols++;
						$tbljg =~ s/\s//g;
					}elsif($cols eq 1){
						$IBUFs .= "&nbsp;$tbljg"; $cols++;
						$tbljg =~ /([0-9][0-9]):([0-9][0-9])/;
						$stim = "$1:$2:00";
						$Eomsgid = $1 . $2 . '00-';
					}elsif($cols eq 2){
						$IBUFs .= " - $tbljg"; $cols++;
						$tbljg =~ /([0-9][0-9]):([0-9][0-9])/;
						$etim = "$1:$2:00";
						$Eomsgid .= $1 . $2 . '00';
					}elsif($cols eq 3){
						$cols++;
						$tbljgp = $tbljg;
						if($tbljgp =~ /station=([0-9]*)/i){
							$sta = $ch{$1};
							if(($ch{$1}) || ($ChAll_enable eq 1)){ $NowCH = 1; }
							$jgh = 1;
						}
					}elsif($cols eq 4){
						$IBUFs .= "&nbsp;($tbljg)<br>"; $cols++;
					}elsif($cols eq 5){
						$tbljg =~ /iepg.php([^"]*)"/; $URIa = $1;
						if($Thumb eq 1){
							$special = &get_Thumb($URIa);
							if(-e "$ThmDir/$special"){
								$sumimg = "<table border=0 class='nres'><td><img border=0 src='$Thm_URL/$special' width=107 height=60></td><td>";
							}else{
								$sumimg = "<table border=0 class='nres'><td><img border=0 src='$Thm_URL/blank.jpg' width=107 height=60></td><td>";
							}
						}
						if($recok eq -1){
							$tbljgp =~ s/<a href.*tv\.php.*onMouseOver=\".*<div[^>]*><h1>(.*)<\/h1>.*<p>(.*)<\/p><p>(.*)<\/p>.*\onMouseOut=\"xhideAlt[^>]*>.*<\/a>/$sumimg<b><font color=#BBBBBB>$1<\/font><\/b>/g;
							if($info_enable eq 1){ $tbljgp .= "<br><font color=#BBBBBB>$2$3<\/font>"; }
						}else{
							if($OpenNewWindow eq 1){
								$tbljgp =~ s/<a href.*tv\.php.*onMouseOver=\".*<div[^>]*><h1>(.*)<\/h1>.*<p>(.*)<\/p><p>(.*)<\/p>.*\onMouseOut=\"xhideAlt[^>]*>.*<\/a>/$sumimg<a href='$URIa' onclick='var wo = window.open(this.href,"view_w", "toolbar=no,directories=no,scrollbars=no,resizable=no,menubar=no,width=320,height=240");wo.resizeTo(320,240);wo.focus();return false;'><b>$1<\/b><\/a>/g;
								$addinfo = "$2$3";
							}else{
								$tbljgp =~ s/<a href.*tv\.php.*onMouseOver=\".*<div[^>]*><h1>(.*)<\/h1>.*<p>(.*)<\/p><p>(.*)<\/p>.*\onMouseOut=\"xhideAlt[^>]*>.*<\/a>/$sumimg<a href='$URIa'><b>$1<\/b><\/a>/g;
								$addinfo = "$2$3";
							}
							if($info_enable eq 1){ $tbljgp .= '<br>' . $addinfo; }
						}
						if($Thumb eq 1){ $tbljgp .= "</td></table>\n"; }
						if($icon_enable ne 1){ $tbljgp =~ s/<img[^>]*>/&nbsp;/g; }
						$IBUFs .= "$tbljgp</td>";
					}else{
						$cols++;
					}
				}
				if($NowCH ne 0){
					$URIa =~ /station=([0-9]*)/; $Eomsgid .= '-' . $chb{$1}; $ch = $chb{$1};
					$URIa =~ /sdate=[0-9][0-9]([0-9][0-9])([0-9][0-9])([0-9][0-9])/;
					$Eomsgid = $1 . $2 . $3 . '-' . $Eomsgid;
					$recok = &jg_recdate($Eomsgid);
					$stday = "$1/$2/$3";
					$URIa = substr($URIa , 1, length($URIa) - 1);
					$lbtsname = $mp4_folder . "\\" . $Eomsgid;
					$lerrname = $log_folder."\\" . $Eomsgid . ".err";
					$breakB =  "&nbsp;<a href='?cachename=$chnam&abort=$Eomsgid'><nobr>「中断」</nobr></a>";
					if(-f "$lerrname"){
						$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
						$glblO .= "■MP4作成に失敗しました";
					}elsif(-f "$lbtsname.np99"){
						$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
						$glblO .= "■他の番組を抽出中です。順番待ちをしています$breakB";
					}else{
						unless(($FBCI{$nRecC} eq "") || (($FBCI{$nRecC} eq 'p') && (-f "$lbtsname.mp4")) || (($FBCI{$nRecC} eq 'i') && (-f "$lbtsname$RwIPOD.mp4"))){
							$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
							unless(-f "$lbtsname.np"){
								unless(-f "$lbtsname.np99"){	# 順番待ち
									if($FBCI{$nRecC} eq 'p'){
										$MkMode= 0;
									}else{
										$MkMode= 1;
									}
									$PofPerl = $^X;
									Win32::Process::Create($ProcessObj, $PofPerl,"$PofPerl encode.pl $lbtsname $lerrname $stday $stim $etim $ch $MkMode", 0, DETACHED_PROCESS, ".");
									$glblO .= "■エンコードを開始しています$breakB";
								}else{
									$glblO .= "■他の番組を抽出中です。順番待ちをしています$breakB";
								}
							}else{
								$Rmsg = &status_vs($lbtsname, "nouri") . $breakB;
								$glblO .= "<font color='red'>" . $Rmsg . "</font>";
							}
						}else{
							$Rmsg = &status_vs($lbtsname, "nouri");
							if($Rmsg ne ""){
								$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
								$glblO .= "<font color='red'>" . $Rmsg . $breakB  . "</font>";
							}elsif($recok eq -1){
								$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
								$glblO .= "■現在録画中です";
							}elsif($recok eq -2){
								$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
								$glblO .= "■まだ録画していません";
							}else{
								$TitleIEnc = "";
								if($brtype eq 1){
									$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
								}else{
									if($RwIPOD ne ""){
										$glblO .= "<tr>" . $IBUFs . "<td align=center width=97>";
									}else{
										$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
									}
									if(-f "$lbtsname.mp4"){
										&get_iepg($URIa);
										$TitleIEnc = &mkFname($TitleI, $Eomsgid, $sta);
										$fisz = (-s "$lbtsname.mp4");
										$fisz = int($fisz / 1024 / 1024);
											$glblO .= "<a href='download.pl?$Eomsgid.mp4&$TitleIEnc%2Emp4'>PC用 ($fisz" . "MB)</a>";
									}else{
											$glblO .= "<input type='checkbox' name='bc' value='$nRecC'>";
									}
									if($RwIPOD ne ""){
										$glblO .= "</td><td align=center width=97>";
									}
								}
								if($RwIPOD ne ""){
									if(-f "$lbtsname$RwIPOD.mp4"){
										$fisz = (-s "$lbtsname$RwIPOD.mp4");
										$fisz = int($fisz / 1024 / 1024);
										if($brtype eq 1){
											$glblO .= "<a href='$mp4_URL$Eomsgid$RwIPOD.mp4'> iPod用($fisz" . "MB)</a>";
										}else{
											$glblO .= "<a href='download.pl?$Eomsgid.mp4&$TitleIEnc$RwIPOD%2Emp4&$RwIPOD'> iPod用($fisz" . "MB)</a>";
										}
									}elsif((-f "$lbtsname.mp4") && ($iencM{$ch} eq 0)){
										$fisz = (-s "$lbtsname.mp4");
										$fisz = int($fisz / 1024 / 1024);
										if($brtype eq 1){
											$glblO .= "<a href='$mp4_URL$Eomsgid.mp4'> iPod用($fisz" . "MB)</a>";
										}else{
											$glblO .= "<a href='download.pl?$Eomsgid.mp4&$TitleIEnc$RwIPOD%2Emp4'> iPod用($fisz" . "MB)</a>";
										}
									}else{
										$glblO .= "<input type='checkbox' name='bci' value='$nRecC'>";
									}
								}
							}
						}
					}
					$glblO .= "</td></tr>\n";
					$nRecC++;
				}
			}else{
				$IBUF .= $RecS;
			}
		}
	}
	&htmlhead("640");
	print '<body>';
	if($glblO ne ""){
		$headt = <<"_EOD_";
<script language='JavaScript'>
function ChkChg(CheckStat, ObjName){
	var i;
	if(CheckStat == true){
		eval("for(i = 0; i < document.chkbat." + ObjName + ".length; i++){ document.chkbat." + ObjName + "[i].checked = true; }");
	}else{
		eval("for(i = 0; i < document.chkbat." + ObjName + ".length; i++){ document.chkbat." + ObjName + "[i].checked = false; }");
	}
}
</script>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style="font-size: 9pt;" width=100%>
<tr><td bgcolor="#EEAAAA"><table border=0 cellpadding=0 cellspacing=0 width=100% style="font-size: 9pt;"><td>■番組表\からの検索結果
</td><td>&nbsp;</td><td align=right><a href='?'>番組検索へ戻る</a></td>
</table>
</td></tr>
<tr><td>
<form method="POST" action="$cginame" name="chkbat">
<div align=right><input type="submit" name="gobatch" value="一括エンコード/最新の情報に更新"></div>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 class="nres" width=100%>
<tr bgcolor="#EEDDDD" align=center><td rowspan=2>番組名</td><td colspan=2 width=200>MP4作成</tr>
_EOD_
	if($brtype eq 1){
			$headt .= "<tr bgcolor='#EEDDDD'><td align=center colspan=2>(iPod用)<br><input type='checkbox' name='chgstat' onClick='ChkChg(this.checked, \"bci\");'></td></tr>";
	}else{
		if($RwIPOD ne ""){
			$headt .= "<tr bgcolor='#EEDDDD' align=center><td>(PC用)<br><input type='checkbox' name='chgstat' onClick='ChkChg(this.checked, \"bc\");'></td>";
			$headt .= "<td>(iPod用)<br><input type='checkbox' name='chgstat' onClick='ChkChg(this.checked, \"bci\");'></td></tr>";
		}else{
			$headt .= "<tr bgcolor='#EEDDDD'><td align=center colspan=2>(PC用)<br><input type='checkbox' name='chgstat' onClick='ChkChg(this.checked, \"bc\");'></td></tr>";
		}
	}
		print $headt;
		print $glblO;
print <<"_EOD_";
</table>
<input type="hidden" name="cachename" value="$chnam">
<div align=right><input type="submit" name="gobatch" value="一括エンコード/最新の情報に更新"></div>
</form>
</body>
</html>
_EOD_
	}else{
		print "<table border=1 style=\"font-size:9pt;\" width=620><td><font color='red'><b>";
		print "<div align='center'><br><br>該当する番組データが存在しないか、検索結果が多すぎます。<br></div>";
		print "<br></td></table></td></tr></table>";
	}
}

sub ttnres {
	local($msg, $chnam) = @_;
	if($CleanShot eq 1){	&expire_file($ThmDir, '*', 'nowlockT', $ExpireShot * 86400); }
	&expire_file($CacheDir, 'htm', 'CacheLockTimeT', $ExpireCache * 3600);
	$OCache = $CacheDir . "\\" . $chnam . '.htm';
	$resbuf = &read_cache($OCache, 'CacheLockTimeT');
	if($resbuf eq ""){
		$ua = new LWP::UserAgent;
		$ua->agent("Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0)" . $ua->agent);
		if($Proxy ne ""){ $ua->proxy('http', $Proxy); }
		my $req = new HTTP::Request GET => $Server . '/tv.php?' . $msg;
		$req->referer($Server . '/tv.php');
		my $res = $ua->request($req); 
		if ($res->is_success) { 
			$resbuf = $res->content;
			if($chnam ne 'none'){
				&cache_write($resbuf, 'CacheLockTimeT', $OCache);
			}
		}else{ 
			&htmlhead();
			print $res->status_line . "\n"; 
			exit(0);
		}
	}
	$begstr = '<table id="bigtable" class="mtx" border="0" cellspacing="1">';
	$engstr = '</table>';
	$glbSO = '';
	$glbSP = '<tr><th class="programTime" style="width:20px;">&nbsp;</th>';
	$glbSH = "<colgroup>\n<col>\n";
	if($ChAll_enable ne 1){
		@CStat = ();
		foreach $cKey (%ch){
			$mchKey = $ch{$cKey};
			push(@CStat, $mchKey);
		}
	}
	$resbuf =~ s/\r\n/\n/sig;
	$resbuf =~ s/\r/\n/sig;
	foreach $RecS (split(/\n/, $resbuf)){
		if($RecS =~ /$begstr/){
			$hitS = 1;
		}elsif(($RecS =~ /$engstr/) && ($hitS gt 0)){
			last;
		}elsif(($RecS =~ /^[\s|\t]+<tr valign=\"middle\">/) && ($hitS eq 2)){
			$glbSO .= $glbSP . '</table>';
			last;
		}elsif($hitS eq 1){ 
			if($RecS =~ /^[\s|\t]*<\/tr/){
				$hitS = 2;
				$glbSP .= "<th class=\"programTime\" style=\"width:20px;\">&nbsp;</th></tr>\n";
				$glbSO = $glbSH . '</colgroup>' . $glbSP;
			}elsif($RecS =~ /^[\s|\t]*(<a href[^>]*>)/){
				$kurlp = $1;
				if($RecS =~ /^[\s|\t]*<a href[^>]*>(.*)<\/a>/){
					$mcS = $1;
					$hsta = 0;
					foreach $mcK (@CStat){
						if($mcK eq $mcS){ $hsta = 1; last; }
					}
					$mcS .= "<BR>";
				}
			}elsif($RecS =~ /^[\s|\t]*(.*)<BR>/){
				$mcS = $1;
				$hsta = 0;
				foreach $mcK (@CStat){
					if($mcK eq $mcS){ $hsta = 1; last; }
				}
				$mcS .= "<BR>";
			
			}elsif($RecS =~ /^[\s|\t]*<\/th>/){
				if(($hsta ne 1) && ($ChAll_enable ne 1)){
						if(($brtype eq 5) || ($brtype eq 6)){	# Opera
							$glbSH .= "<col style='width:1px;'>\n";
						}else{
							$glbSH .= "<col style='width:0px;'>\n";
						}
						if($brtype eq 7){ 	# ps3
							$glbSP .= "<th scope='row' width='0'></th>\n";
						}else{
							$glbSP .= "<th scope='row'></th>\n";
						}
				}else{
						$glbSH .= "<col>\n";
						$glbSP .= '<th scope="row">' . $kurlp . $mcS . "</a></th>\n";
				}
			}
		}elsif($hitS eq 2){ 
			if($RecS =~ /station=([0-9]*)/i){
					if(($ch{$1}) || ($ChAll_enable eq 1)){ 
						$ot = 1; $nt = 2;
						if($RecS =~ /sdate=([0-9][0-9][0-9][0-9])([0-9][0-9])([0-9][0-9])/i){
							$yy = sprintf("%01d", $1);
							$mm = sprintf("%01d", $2);
							$dd = sprintf("%01d", $3);
							$RecS =~ /shour=([0-9]*)/i; $th =  sprintf("%01d", $1);
							$RecS =~ /sminutes=([0-9]*)/i; $tm =  sprintf("%01d", $1);
							$ot = timelocal(0, $tm, $th, $dd, $mm - 1, $yy);
							$nt = time;
						}
						if($ot >= $nt){
							$RecS =~ s/<a href=\"javascript.*onClick=\"xClickACT\(\'\.\/tv\.php([^\']*)\'.*\" onMouseOver=\".*<div[^>]*><h1>.*<\/h1><h2>.*<\/h2><p>(.*)<\/p><p>(.*)<\/p>.*onMouseOut=\"xhideAlt[^>]*>(.*)<\/A>/<b><font color=#BBBBBB>$4<\/font><\/b><\!-- -->/g;
							$addinfo = &decode_sp("$2$3");
							$addinfo =~ s/<a[\s]*href[^>]*>//ig;
							$addinfo =~ s/<\/a>//ig;
							if($info_enable eq 1){ $RecS =~ s/<\!-- -->.*<\/DIV>/<font color=#BBBBBB>$addinfo<\/a><\/DIV>/; }
							if($icon_enable ne 1){ $RecS =~ s/<img[^>]*>/&nbsp;/g; }
						}else{
							if($OpenNewWindow eq 1){
								$RecS =~ s/<a href=\"javascript.*onClick=\"xClickACT\(\'\.\/tv\.php([^\']*)\'.*\" onMouseOver=\".*<div[^>]*><h1>.*<\/h1><h2>.*<\/h2><p>(.*)<\/p><p>(.*)<\/p>.*onMouseOut=\"xhideAlt[^>]*>(.*)<\/A>/<a href='$1' onclick='var wo = window.open(this.href,"view_w", "toolbar=no,directories=no,scrollbars=no,resizable=no,menubar=no,width=320,height=240");wo.resizeTo(320,240);wo.focus();return false;'>RepMark<b>$4<\/b><\/a>/g;
								$addinfo = &decode_sp("$2$3");
							}else{
								$RecS =~ s/<a href=\"javascript.*onClick=\"xClickACT\(\'\.\/tv\.php([^\']*)\'.*\" onMouseOver=\".*<div[^>]*><h1>.*<\/h1><h2>.*<\/h2><p>(.*)<\/p><p>(.*)<\/p>.*onMouseOut=\"xhideAlt[^>]*>(.*)<\/A>/<a href='$1'>RepMark<b>$4<\/b><\/a>/g;
								$addinfo = &decode_sp("$2$3");
							}
							$addinfo =~ s/<a[\s]*href[^>]*>//ig;
							$addinfo =~ s/<\/a>//ig;
							if($info_enable eq 1){ $RecS =~ s/<\/a>.*<\/DIV>/<\/a>$addinfo<\/DIV>/; }
							if($icon_enable ne 1){ $RecS =~ s/<img[^>]*>/&nbsp;/g; }
						}
					}else{
						$RecS =~ s/(<td[^>]*>).*(<\/td>)/$1$2/i;
					}
					$RecS =~ s/<div[^>]*>//ig;
					$RecS =~ s/<\/div[^>]*>//ig;
			}
			$RecS =~ s/<td.*rowspan[\s]*=[\s]*([0-9]+).*class[\s]*=[\s]*\"([^\"]*)\"[^>]*>/<td rowspan=$1 class=$2>/ig;
			$RecS =~ s/<th.*rowspan[\s]*=[\"]*([0-9]+)[^>]*>/<th rowspan=$1>/ig;
			if($Thumb eq 1){
				$special = &get_Thumb($RecS);
				if(-e "$ThmDir/$special"){
					$sumimg = "<img border=0 src='$Thm_URL/$special' width=107 height=60><br>";
				}else{
					$sumimg = "<img border=0 src='$Thm_URL/blank.jpg' width=107 height=60><br>";
				}
			}
			$RecS =~ s/RepMark/$sumimg/;
			$glbSO .= $RecS . "\n";
		}
	}
	$glbSO = "<div class='ttbl'><table border=0 cellspacing=0 cellpadding=3>" . $glbSO . "</div>";
}

sub get_iepgURL {
	local($msg) = @_;
	local($IEPGURL);
	$ua = new LWP::UserAgent;
	$ua->agent("Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0)" . $ua->agent);
	if($Proxy ne ""){ $ua->proxy('http', $Proxy); }
	my $req = new HTTP::Request GET => $Server . '/tv.php?' . $msg;
	$req->referer($Server . '/tv.php');
	my $res = $ua->request($req); 
	if ($res->is_success) { 
		$resbuf = $res->content;
	}else{ 
		return "";
	}
	foreach $RecS (split(/\n/, $resbuf)){
		if($RecS =~ /iepg.php\?([^"]*)"/){
			$IEPGURL = $1;
			last;
		}
	}
	return $IEPGURL;
}

sub get_iepg {
	local($msg) = @_;
	$msg =~ /station=([0-9]*)/; $chepg = $1;
	$msg =~ /sdate=([0-9]*)/; $chepg .= $1;
	$msg =~ /shour=([0-9]*)/; $chepg .= $1;
	$msg=~ /sminutes=([0-9]*)/; $chepg .= $1;
	&expire_file($CacheDir, 'epg', 'CacheLockEPG', $ExpireEPG * 3600);
	$OCache = $CacheDir . "\\" . $chepg . '.epg';
#$resbuf="";
	$resbuf = &read_cache($OCache, 'CacheLockEPG');
	if($resbuf eq ""){
		$ua = new LWP::UserAgent;
		$ua->agent("Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0)" . $ua->agent);
		if($Proxy ne ""){ $ua->proxy('http', $Proxy); }
		my $req = new HTTP::Request GET => $Server . '/iepg.php?' . $msg;
		$req->referer($Server . '/tv.php');
		my $res = $ua->request($req); 
		if ($res->is_success) { 
			$resbuf = $res->content;
			$resbuf = encode('utf8', decode('shiftjis', $resbuf));
			&cache_write($resbuf, 'CacheLockEPG', $OCache);
		}else{ 
			&htmlhead();
			print $res->status_line . "\n"; 
		}	 
	}

	if($resbuf ne ""){
		$sta = $chan = $YearI = $MonI = $DatI = $StatI = $EndI = $TitleI = $TitleSI = "";
		foreach $RecS (split(/\n/, $resbuf)){
			if($RecS =~ /station:/){
				($filler, $objStation) = split(/:/, $RecS);
				$objStation =~ s/\r|\n|\s//g;
				foreach $chanTmp (@iepg_chan){
					($ChanObj, $stations) = split(/:/, $chanTmp);
					foreach $station (split(/\,/, $stations)){
						if($objStation eq $station){
							$chan = $ChanObj; $sta = $station;
							last;
						}
					}
					if($chan ne ""){ last; }
				}
			}elsif($RecS =~ /year:/){
				($filler, $YearI) = split(/:/, $RecS);
				$YearI =~ s/\r|\n|\s//g;
				if(length($YearI) > 2){
					$YearI = substr($YearI, 2, 2);
				}else{
					$YearI = sprintf("%02d", $YearI);
				}
			}elsif($RecS =~ /month:/){
				($filler, $MonI) = split(/:/, $RecS);
				$MonI =~ s/\r|\n|\s//g;
				$MonI = sprintf("%02d", $MonI);
			}elsif($RecS =~ /date:/){
				($filler, $DatI) = split(/:/, $RecS);
				$DatI =~ s/\r|\n|\s//g;
				$DatI = sprintf("%02d", $DatI);
			}elsif($RecS =~ /start:/){
				$StatI = $RecS;	$StatI =~ s/start://i;
				$StatI =~ s/\r|\n|\s|://g;
				$StatI = sprintf("%04d00", $StatI);
			}elsif($RecS =~ /end:/){
				$EndI = $RecS;	$EndI =~ s/end://i;
				$EndI =~ s/\r|\n|\s|://g;
				$EndI = sprintf("%04d00", $EndI);
			}elsif($RecS =~ /program-title:/){
				$TitleI = $RecS;	$TitleI =~ s/program-title://i;
				$TitleI = &special_repl($TitleI);
			}elsif($RecS =~ /program-subtitle:/){
				$TitleSI = $RecS;	$TitleSI =~ s/program-subtitle://i;
				$TitleSI = &special_repl($TitleSI);
			}elsif($RecS =~ /performer:/){
				$TitleSP = $RecS;	$TitleSP =~ s/performer://i;
				$TitleSP = &special_repl($TitleSP);
			}
		}
	}
}

sub expire_file {
	($objdir, $objext, $lockf, $Expire) = @_;
	$locktrue = 1;
	if($lockf ne 'NoLock'){
		open(LK, ">$log_folder\\$lockf");
		unless(flock(LK, 6)){ $locktrue = 0; }
	}
	if($locktrue eq 1){
		opendir(DIB,"$objdir");
		while($DirObj = readdir(DIB)){
			if(($objext = '*') || ($DirObj =~ /$objext$/)){
					@retval = stat("$objdir\\$DirObj");
					if($retval[9] < (time - $Expire)){
					unlink("$objdir\\$DirObj");
				}
			}
		}
		closedir(DIB);
		if($lockf ne 'NoLock'){	close(LK); }
	}
}

sub cache_write {
	($wrtBuf, $lockf, $CFName) = @_;
	open(LK, ">$log_folder\\$lockf");
	if(flock(LK, 6)){
		if(open(OUC, ">$CFName")){
			print OUC $wrtBuf;
			close(OUC);
		}
		close(LK);
	}
}

sub read_cache {
	($CFName, $lockf) = @_;
	local($RecB, $thit);
	$RecB = "";
	$thit = 0;
	open(LK, ">$log_folder\\$lockf");
	if(flock(LK, 6)){
		if(open(INC, $CFName)){
			while($rec = <INC>){
				if(($rec =~ /<table/i) && ($CFName =~ /.htm$/)){ $thit = 1; }
				if(($rec =~ /^station:/i) && ($CFName =~ /.epg$/)){ $thit = 1; }
				$RecB .= $rec;
			}
			close(INC);
		}
		close(LK);
	}

	if($thit eq 0){
		unlink($CFName);
		$RecB = "";
	}
	return $RecB;
}

sub special_repl {
	local($SP) = @_;
	$SP =~ s/\r|\n//g;
	$SP =~ s/^\s*//g;
	$SP =~ s/&/&amp;/g;
	$SP =~ s/</&lt;/g;
	$SP =~ s/>/&gt;/g;
	$SP =~ s/"/&quot;/g;
	$SP;
}

sub decode_sp {
	local($SP) = @_;
	$SP =~ s/&quot;/"/g;
	$SP =~ s/&lt;/</g;
	$SP =~ s/&gt;/>/g;
	$SP =~ s/&amp;/&/g;
	$SP;
}

sub jg_recdate {
	local($dtF) = @_;
	local($day, $st_tim, $ed_tim);
	($day, $st_tim, $ed_tim) = split(/-/, $dtF);
	$yy = substr($day,0,2); $mm = substr($day,2,2); $dd = substr($day,4,2);
	$h = substr($st_tim,0,2); $m = substr($st_tim,2,2); $s = substr($st_tim,4,2);
	$stimmin = $h * 3600 + $m * 60;
	$h = substr($ed_tim,0,2); $m = substr($ed_tim,2,2); $s = substr($ed_tim,4,2);
	$etimmin = $h * 3600 + $m * 60;
	if($stimmin > $etimmin){
		$lapt = 86400 + $etimmin;
		$sapt = $stimmin;
	}else{
		$lapt = $etimmin;
		$sapt = $stimmin;
	}
	$fot = timelocal(0,0,0,$dd, $mm-1, $yy);
	$fots = $fot + $sapt;
	$fote = $fot + $lapt;
	$nt = time;
	if($fote > $nt){
		if($fots > $nt){
			return -2;
		}else{
			return -1;
		}
	}else{
		return 1;
	}
}


 
sub mkFname {
	local($TitleIs, $request_s, $sta_s) = @_;
	if($TitleIs =~ /\\|\/|:|\*|\"\<|\>|\||/){
		#&jcode'convert(*TitleIs, 'euc');
		$TitleIs =~ s/\\|\/|:|\*|\"\<|\>|\||//g;
		#&jcode'convert(*TitleIs, 'sjis');
	}
	if($TitleIs eq ""){
		$TitleIs = $request_s;
	}else{
		$TitleIs = substr($request_s, 0, 6) . '-' . $sta_s . "「$TitleIs」";
	}
	$TitleIs =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
	return $TitleIs;
}

sub get_shot {
	local($requestl) = @_;
	($stdayT, $stimT, $Filler, $chl) = split(/-/, $requestl);
	$requestl = "$ShotDir\\$requestl";
	$stdayl = substr($stdayT, 0, 6);
	$h = substr($stimT, 0, 2); $m = substr($stimT, 2, 2);
	$stiml = "$h$m" . '05';
	$etiml = "$h$m" . '55';
	unless(-f "$requestl.jpg"){
		open(CL, ">$requestl.jpg"); close(CL);
		&expire_file($ShotDir, '*', 'nowlockS', $ExpireShot * 86400);
		$file = $stdayl . "-" . $stiml . "-" .  $etiml . "-" . $chl;
		$opt = O_RDONLY | O_BINARY;
		eval { $opt |= O_LARGEFILE; };
		if(open(OTS, ">$requestl.ts")){
			binmode(OTS);
			segwrapper::segopen($handle, $file, $opt);
			while(segwrapper::segread($handle, my $buf, $packet_size)) {
				print OTS $buf;
			}
			segwrapper::segclose($handle);
			close(OTS);
		}
		$fiszts = (-s "$requestl.ts");
		if($fiszts > 0){
			open(IN, "$FFMpeg -y -i $requestl.ts -ss $ShotS -b 128 -vframes 1 -s 320x180 -an $requestl.jpg |");
			while(<IN>){ print;}
			close(IN);
		}else{
			unlink "$requestl.jpg";
		}
		unlink "$requestl.ts";
	}
}

sub MakeCal {
	local($MonSw) = @_;
	@youbi = ('日','月','火','水','木','金','土');
	@WeekDayM = (
		'-1,0,0,-1,',
		'-1,0,0,-1,',
		'-1,1,1,-1,元旦',
		'-1,1,-1,2,成人の日',
		'-1,2,11,-1,建国記念日',
		'-1,4,29,-1,昭和の日',
		'-1,5,3,-1,憲法記念日',
		'-1,5,4,-1,みどりの日',
		'-1,5,5,-1,こどもの日',
		'-1,7,-1,3,海の日',
		'-1,9,-1,3,敬老の日',
		'-1,10,-1,2,体育の日',
		'-1,11,3,-1,文化の日',
		'-1,11,23,-1,勤労感謝の日',
		'-1,12,23,-1,天皇誕生日'
	);

	$ChkDay = 0;
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	$Mond = $mon;
	$YearC = $year + 1900;
	if($MonSw eq 0){
		$ChkDay = $mday;
		$Mond += 1;
	}elsif(($MonSw > 0) && (($mon + $MonSw) > 11)){
		$YearC += 1;
		$Mond += $MonSw - 11;
	}elsif(($MonSw < 0) && (($mon + $MonSw) < 0)){
		$YearC -= 1;
		$Mond += $MonSw + 13;
	}else{
		$Mond += $MonSw + 1;
	}

	if($YearC < 1900){ $YearC += 1900;}
	@monthday = (0,31,28,31,30,31,30,31,31,30,31,30,31);
	$Tmpweek = ($YearC - 1) + int(($YearC - 1) / 4) - int(($YearC - 1) / 100) + int(($YearC - 1) / 400);
	if($YearC % 400 eq 0 || ($YearC % 100 ne 0 && $YearC % 4 eq 0)) {
		$monthday[2] = 29;
	}
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time - $start_date * 86400);
	$YearBk = $year + 1900;
	$MondBk = $mon;
	$DayBk  = $mday;
	if($YearBk < 1900){ $YearBk += 1900;}
	$MondBk += 1;
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time + 7 * 86400);

	$YearFk = $year + 1900;
	$MondFk = $mon;
	$DayFk  = $mday;
	if($YearFk < 1900){ $YearFk += 1900;}
	$MondFk += 1;
	$TmpDay = 0;
	for($i=1; $i < $Mond; $i++){
		$TmpDay += $monthday[$i];
	}
	$Weekd = ($Tmpweek + ($TmpDay % 7)) % 7;
	if($Weekd > 5) {
		$Weekd = 0;
	}else{
		$Weekd += 1;
	}
	$Tday = int(20.8431 + 0.242194 * ($YearC - 1980) - int(($YearC - 1980) / 4));
	$WeekDayM[0] = "-1,3,$Tday,-1,春分の日";
	$Tday = int(23.2488 + 0.242194 * ($YearC - 1980) - int(($YearC - 1980) / 4));
	$WeekDayM[1] = "-1,9,$Tday,-1,秋分の日";
	$Tmpweek = ($YearC - 1) + int(($YearC - 1) / 4) - int(($YearC - 1) / 100) + int(($YearC - 1) / 400);
	if($YearC % 400 eq 0 || ($YearC % 100 ne 0 && $YearC % 4 eq 0)) {
		$monthday[2] = 29;
	}
	$TmpDay = 0; $HitDay = 0; $OutStr = "";
	for($i=1; $i < $Mond; $i++){ $TmpDay += $monthday[$i]; }
	$Weekd = ($Tmpweek + ($TmpDay % 7)) % 7;

	if($Weekd > 5) { $Weekd = 0; }
	else{ $Weekd += 1; }
	$OutStr .= "<TABLE BORDER=0 style='font-size: 9pt;' width=150>";
	$OutStr .= "<TR><TD COLSPAN=7 BGCOLOR='#DDDDDD' nowrap valign=top>";
	$OutStr .= "<DIV ID='statview" . $Mond . "' style='width:142px;font-size:9pt;'>" . $YearC . "年" . $Mond . "月</DIV>";
	$OutStr .= "</TD></TR>";
	$OutStr .= "<TR BGCOLOR='#EEEEEE' align=center><TD BGCOLOR='#FFCCCC'>日</TD>";
	$OutStr .= "<TD>月</TD><TD>火</TD><TD>水</TD><TD>木</TD><TD>金</TD>";
	$OutStr .= "<TD BGCOLOR='#CCCCFF'>土</TD></TR>";
	if($Weekd > 0){
		$OutStr .= "<TR BGCOLOR='#FFFFFF' ALIGN=center>";
		for($i=0; $i < $Weekd; $i++){
			$OutStr .= "<TD><FONT COLOR='#FFFFFF'>&nbsp;</FONT></TD>";
		}
	}
	$furDay = 0;	$MonCnt = $HitKday = 0;
	for($j=1; $j <= $monthday[$Mond]; $j++){
		$HitSday = 0; $WeeDtg = "";
		$Weektmp = ($Weekd + $j -1 ) % 7;
		if($Weektmp eq 1){ $MonCnt++; }
		if($Weektmp eq 0){ $OutStr .= "<TR BGCOLOR='#FFFFFF' ALIGN=center>"; }
		$WeekDayM_lengh = @WeekDayM;
		for($wi=0; $WeekDayM_lengh > $wi; $wi++){
			($YerT, $MonT, $WeeT, $WsmT, $WedT) = split(/\,/, $WeekDayM[$wi]);
			if(($YerT eq -1) && ($MonT eq $Mond) &&
				(($WeeT eq $j) ||
				(($WeeT eq -1) && ($WsmT eq $MonCnt) && ($Weektmp eq 1)))){
				$WeeDtg = $WedT;
				$HitSday = $HitKday = 1;
				last;
			}
			if(($YerT eq $YearC) && ($MonT eq $Mond) && ($WeeT eq $j)){
				$WeeDtg = $WedT;
				$HitSday = 1;
				last;
			}
		}
		if(($HitSday ne 1) && ($HitKday eq 1) && ($Weektmp ne 0)){	
			$dj = $j + 1;
			$Weektmpd = ($Weekd + $dj -1 ) % 7;
			for($wi=0; $WeekDayM_lengh > $wi; $wi++){
				($YerT, $MonT, $WeeT, $WsmT, $WedT) = split(/\,/, $WeekDayM[$wi]);
				if(($YerT eq -1) && ($MonT eq $Mond) && ($WeeT eq $dj)){
					$WeeDtg = '国民の休日';
					$HitSday = 1;
					last;
				}
			}
			$HitKday = 0;
		}
		if($HitSday eq 1){
			if($Weektmp eq 0){ $furDay = 1; }
			$OtStrTp = "<TD BGCOLOR='#FFCCCC'";
		}else{
			if($furDay eq 1){
				$WeeDtg = "振替休日";
				$OtStrTp = "<TD BGCOLOR='#FFCCCC'";
				$furDay = 0;
			}elsif($Weektmp eq 0){
				$OtStrTp = "<TD BGCOLOR='#FFCCCC'";
			}elsif($Weektmp eq 6){
				$OtStrTp = "<TD BGCOLOR='#CCCCFF'";
			}else{
				$OtStrTp = "<TD";
			}
		}
		if($j eq $ChkDay){
			$OtStrTp = "<TD BGCOLOR='#AAFF55'";
		}
		$OutStr .= $OtStrTp;

		$fmtDate = sprintf("%04d%02d%02d", $YearC, $Mond, $j);
		$Outcapt = $YearC . "年" . $Mond . "月" . $j .  "日" . "(" . $youbi[$Weektmp] . ") " . $WeeDtg;
		if($WeeDtg ne ""){
			$Outcapt1 = $Mond . "月" . $j .  "日" . " " . $WeeDtg;
		}else{
			$Outcapt1 = $Mond . "月" . $j .  "日" . "(" . $youbi[$Weektmp] . ")";
		}
		$Outcapt2 = $YearC . "年" . $Mond . "月";

		unless($brtype eq 1){
			$OutStr .= " onMouseOver=\"document.all.statview" . $Mond . ".innerHTML='" . $Outcapt1 . "'; window.status='" . $Outcapt . "'; return true;\"";
			$OutStr .= " onFocus=\"document.all.statview" . $Mond . ".innerHTML='" . $Outcapt1 . "'; window.status='" . $Outcapt . "';return true;\"";
			$OutStr .= " onMouseOut=\"document.all.statview" . $Mond . ".innerHTML='" . $Outcapt2 . "'; window.status=''; return true;\"";
		}

		$OutStr .= ">";
		if((($YearBk < $YearC) || (($YearBk eq $YearC) && (($MondBk < $Mond) || (($MondBk eq $Mond) && ($DayBk < $j))))) && (($YearFk > $YearC) || (($YearFk eq $YearC) && (($MondFk > $Mond) || (($MondFk == $Mond) && ($DayFk > $j)))))){
			$OutStr .= "<A HREF=\"JavaScript:click_day('" . $fmtDate . "')\">";
			$OutStr .= "<b>" . $j . "</b></A></TD>";
			$HitDay = 1;
		}else{
			$OutStr .= "<font color='#bbbbbb'>" . $j . "</font></TD>";
		}
		if($Weektmp == 6){
			$OutStr .= "</TR>";
		}
	}
	if($Weektmp < 6){
		for($i=$Weektmp; $i < 6; $i++){
			$OutStr .= "<TD><FONT COLOR='#FFFFFF'>&nbsp;</FONT></TD>";
		}
		$OutStr .= "</TR>";
	}
	$OutStr .= "</TABLE>";
	if($HitDay eq 1){ return $OutStr; }

}

sub get_Thumb {
	local($URc) = @_;
	$special = '';
	$URc =~ /sdate=[0-9][0-9]([0-9]*)/; $special .= $1 . '-';
	$URc =~ /shour=([0-9]*)/i; $special .=  sprintf("%02d", $1);
	$URc =~ /sminutes=([0-9]*)/i; $special .=  sprintf("%02d", $1);
	$URc =~ /station=([0-9]*)/; $special .= '00-xxxxxx-' . $chb{$1} . '.jpg';
	return $special;
}
